package cn.net.caoyao.cpzshandset.service.thread.impl.common;

import java.io.IOException;
import java.net.BindException;
import java.net.ConnectException;
import java.net.SocketTimeoutException;
import java.net.UnknownHostException;
import java.util.HashMap;
import java.util.Map;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Handler;
import android.os.Message;
import android.util.Log;

import com.google.gson.Gson;

import cn.net.caoyao.cpzshandset.bean.ActivateBean;
import cn.net.caoyao.cpzshandset.bean.SubmitBean;
import cn.net.caoyao.cpzshandset.bean.UploadBean;
import cn.net.caoyao.cpzshandset.common.config.Config;
import cn.net.caoyao.cpzshandset.common.config.HandsetOperation;
import cn.net.caoyao.cpzshandset.common.config.RequestConstant;
import cn.net.caoyao.cpzshandset.common.config.TConfig;
import cn.net.caoyao.cpzshandset.common.util.LogUtil;
import cn.net.caoyao.cpzshandset.service.bll.ActivateBll;
import cn.net.caoyao.cpzshandset.service.bll.BatchLabelBll;
import cn.net.caoyao.cpzshandset.service.bll.UploadStatusBll;
import cn.net.caoyao.cpzshandset.service.presenter.LoginApis;
import cn.net.caoyao.cpzshandset.ui.activity.LoginActivity;
import cn.net.cpzslibs.prot.Prot02Logout;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.bean.res.ProtStatusResBean;
import cn.net.cpzslibs.prot.handset.bean.req.Prot20002ReqBatchBean;
import cn.net.cpzslibs.prot.handset.bean.req.Prot20002ReqBean;
import cn.net.cpzslibs.prot.handset.newProt.Prot20002Activate;
import io.reactivex.Observable;
import io.reactivex.Observer;
import io.reactivex.android.schedulers.AndroidSchedulers;
import io.reactivex.disposables.Disposable;
import io.reactivex.schedulers.Schedulers;
import okhttp3.MediaType;
import okhttp3.RequestBody;
import okhttp3.ResponseBody;
import retrofit2.Retrofit;
import retrofit2.adapter.rxjava2.RxJava2CallAdapterFactory;
import retrofit2.converter.gson.GsonConverterFactory;

public class CommonSubmitSingleBatchActivateThread implements Runnable {
	private long deviceId;
	private ActivateBll bll;
	private BatchLabelBll batchBll;
	private UploadStatusBll uploadStatusBll;
	private ActivateBean activateBean;
	private Prot20002ReqBatchBean batchBean;
	private Handler mHandler;
	private int option_type = HandsetOperation.OPERATION_ACTIVATE_CONSTANT.getOption();
	private Context context;
	public CommonSubmitSingleBatchActivateThread(Handler mHandler, long deviceId, ActivateBll bll,
			BatchLabelBll batchBll, UploadStatusBll uploadStatusBll, ActivateBean activateBean,
			Prot20002ReqBatchBean batchBean,Context context) {
		this.mHandler = mHandler;
		this.deviceId = deviceId;
		this.bll = bll;
		this.uploadStatusBll = uploadStatusBll;
		this.activateBean = activateBean;
		this.batchBean = batchBean;
		this.batchBll = batchBll;
		this.context = context;
	}

	@Override
	public void run() {
		try {
			submitActivateInfo();
		} catch (IOException e) {
			e.printStackTrace();
		}
//		SocketCreate create = new SocketCreate(Config.ip, Config.port, "");
//		try {
//			LogUtil.d(TConfig.Echo, "登录");
//			create.createLoginCpzsHandset(deviceId);
//			if (create.isResult()) {
//				submitActivateInfo(create);
//			} else {
//				Message msg = new Message();
//				msg.what = RequestConstant.REQUEST_PROT01_LOGIN_FAIL;
//				msg.arg1 = create.getiErrCode();
//				msg.obj = create.getErrMsg();
//				mHandler.sendMessage(msg);
//			}
//
//		} catch (BindException e) {
//			e.printStackTrace();
//			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
//		} catch (ConnectException e) {
//			e.printStackTrace();
//			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
//		} catch (SocketTimeoutException e) {
//			e.printStackTrace();
//			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL_SOCKET_TIMEOUT);
//		} catch (UnknownHostException e) {
//			e.printStackTrace();
//			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
//		} catch (IOException e) {
//			e.printStackTrace();
//			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
//		} finally {
//			new Prot02Logout().dealLogout(create);
//		}
	}

	private void submitActivateInfo() throws IOException, SocketTimeoutException {
//		Prot20002Activate activate = new Prot20002Activate();
//		activate.submitActivateInfo(create, getReqBean());
//		ProtStatusResBean resBean = activate.getResBean();
//		if (resBean == null) {
//			mHandler.sendEmptyMessage(RequestConstant.SUBMIT_ACTIVATE_WITHOUT_RES);
//			return;
//		}
//
//		LogUtil.d(TConfig.Echo, "批量激活：" + resBean.toString());



		SharedPreferences user_token =context.getSharedPreferences("data", 0);
		String token = user_token.getString("appToken", "");
		Log.d("我提交的===》参数",token);
		Map<String,Object> map=new HashMap<>();
		map.put("batchNumber",Long.valueOf(activateBean.getProduct_batch_number()));
		map.put("companyId",activateBean.getCompany_id());
		map.put("productId",Long.valueOf(activateBean.getProduct_id()));
		map.put("endTag",batchBean.getEnd());
		map.put("startTag",batchBean.getStart());
		Gson gson=new Gson();
		String s = gson.toJson(map);
		Log.d("我提交的===》参数",s);
		RequestBody requestBody = RequestBody.create(MediaType.parse("application/json; charset=utf-8"), s);


		Retrofit retrofit = new Retrofit.Builder()
				.baseUrl(Config.caoyaoUrl)
				.addConverterFactory(GsonConverterFactory.create())
				.addCallAdapterFactory(RxJava2CallAdapterFactory.create())
				.build();
		LoginApis loginApis = retrofit.create(LoginApis.class);
		Observable<ResponseBody> observable=loginApis.getBatchSubmit("Bearer  "+token,requestBody);
		observable.subscribeOn(Schedulers.io());
		observable.observeOn(AndroidSchedulers.mainThread());
		observable.subscribe(new Observer<ResponseBody>() {
			@Override
			public void onSubscribe(Disposable d) {
			}
			@Override
			public void onNext(ResponseBody value) {
				try {
					String string = value.string();
					Log.d("我上传之后的===》",string);
					Gson gson = new Gson();
					SubmitBean submitBean= gson.fromJson(string, SubmitBean.class);
					int code = submitBean.getCode();
					if (code==200){
						Log.i("我上传之后的===》","111111111111333");
						// 上传成功，插入记录到提交状态表
						uploadStatusBll.insertUploadStatus(getUploadBean(activateBean));
						bll.delActivateById(activateBean);
					}else if (code==401){
						SharedPreferences sp=context.getSharedPreferences("data",0);
						SharedPreferences.Editor edit = sp.edit();
						edit.putString("appToken","");
						edit.commit();
						Intent intent = new Intent(context, LoginActivity.class);
						context.startActivity(intent);
					}else {
						Log.i("我上传之后的===》","111111111111444");
						batchBll.insertBatch(option_type, activateBean.getId(), batchBean);
						bll.updateActivateErrorById(submitBean.getCode(), activateBean.getId());
//						LogUtil.i(TConfig.Echo, "else activateId:" + activateBean.toString());
					}
					Message msg = mHandler.obtainMessage(RequestConstant.SUBMIT_ACTIVATE_WITH_RES);
					msg.obj = submitBean;
					msg.what = RequestConstant.SUBMIT_ACTIVATE_WITH_RES;
					mHandler.sendMessage(msg);


				} catch (IOException e) {
					Log.d("我上传之后的===》",e.getMessage());
				}
			}

			@Override
			public void onError(Throwable e) {
				Log.d("我上传之后的===》",e.getMessage());
			}

			@Override
			public void onComplete() {

			}
		});





































//		if (resBean.getResult() == 0) {
//			// 上传成功，插入记录到提交状态表
//			uploadStatusBll.insertUploadStatus(getUploadBean(activateBean));
//			bll.delActivateById(activateBean);
//			// bll.delActivateById(activateBean.getId());
//			// batchBll.deleteBatchById(HansetOperationConstant.OPERATION_ACTIVATE_CONSTANT,
//			// activateBean.getId());
//		} else {
//			batchBll.insertBatch(option_type, activateBean.getId(), batchBean);
//			bll.updateActivateErrorById(resBean.getErrcode(), activateBean.getId());
//			LogUtil.i(TConfig.Echo, "else activateId:" + activateBean.toString());
//		}
//		Message msg = mHandler.obtainMessage(RequestConstant.SUBMIT_ACTIVATE_WITH_RES);
//		msg.obj = resBean;
//		msg.what = RequestConstant.SUBMIT_ACTIVATE_WITH_RES;
//		mHandler.sendMessage(msg);

	}

	private UploadBean getUploadBean(ActivateBean activateBean) {
		UploadBean b = new UploadBean();
		b.setLabel_count(batchBll.queryBatchCountById(option_type, activateBean.getId()));
		b.setOption_type(option_type);
		return b;
	}

	private Prot20002ReqBean getReqBean() {
		Prot20002ReqBean reqBean = new Prot20002ReqBean();
		reqBean.setProduct_id(activateBean.getProduct_id());
		reqBean.setProducer(activateBean.getProducer());
		reqBean.setProduce_date(activateBean.getProduct_date());
		reqBean.setProduce_batch(activateBean.getProduct_batch_number());
		reqBean.setType(Config.BATCH_OPTION_LABEL_TYPE);
		reqBean.setBatcher(batchBean);
		LogUtil.i(TConfig.Echo, "提交的数据：" + reqBean.toString());
		return reqBean;
	}

}
